%%******************************************************
%% Run this script in Matlab command window
%%
%% SDPNAL:
%% Copyright (c) 2008 by
%% Xinyuan Zhao, Defeng Sun, and Kim-Chuan Toh
%%**********************************************************
%% DSA_BD:
%% Modified by C.Ortiz
%% Last Modified: 3/31/2011

function Install_DSA_BD

%% Add necessary folders

addpath(strcat(pwd,'/solver'));
addpath(strcat(pwd,'/solver/mexfun'));
addpath(strcat(pwd,'/util'));
addpath(strcat(pwd,'/datafiles'));

savepath;

%%

computer_model = computer;
matlabversion = sscanf(version,'%f');
matlabversion = matlabversion(1);
tmp = version('-release');
matlabrelease = str2num(tmp(1:4));
%%
if strcmp(computer_model,'PCWIN')
    str1 = ['  ''',matlabroot,'\extern\lib\win32\lcc\libmwlapack.lib''  '];
    str2 = ['  ''',matlabroot,'\extern\lib\win32\lcc\libmwblas.lib''  '];
    libstr = [str1,str2];
elseif strcmp(computer_model,'PCWIN64')
    str1 = ['  ''',matlabroot,'\extern\lib\win64\lcc\libmwlapack.lib''  '];
    str2 = ['  ''',matlabroot,'\extern\lib\win64\lcc\libmwblas.lib''  '];
    libstr = [str1,str2];
else
    libstr = '  -lmwlapack -lmwblas  ';
end
mexcmd = 'mex -O  -largeArrayDims  -output ';
%%
if (matlabversion < 7.3)  & (matlabrelease <= 2008)
    error(' DSA-BD works only for MATLAB version 7.4 and above');
end
fsp = filesep;

curdir = pwd;
fprintf(' current directory is:  %s\n',curdir);
%%
%% generate mex files in mexfun
%%
clear fname

src = [curdir,fsp,'solver',fsp,'mexfun'];
eval(['cd ','solver',fsp,'mexfun']);
fprintf ('\n Now compiling the mexFunctions in:\n');
fprintf (' %s\n',src);
%%
fname{1} = 'mexbwsolve';
fname{2} = 'mexfwsolve';
fname{3} = 'mexmat';
fname{4} = 'mexsmat';
fname{5} = 'mexsvec';
fname{6} = 'mextriang';
fname{7} = 'mexScalarxMatrix';

for k = 1:length(fname)
    cmd([mexcmd,fname{k},'  ',fname{k},'.c  ',libstr]);
end

if strcmp(computer_model,'PCWIN')
    cmd([mexcmd,'mexeig','  ','mexeigwin','.c  ',libstr]);
else
    cmd([mexcmd,'mexeig','  ','mexeig','.c  ',libstr]);
end
fprintf ('\n Compilation of mexFunctions completed.\n');
cd ..
cd ..
%%***********************************************
function cmd(s)

fprintf(' %s\n',s);
eval(s);
%%***********************************************
