% LegendAppend: Write the short description of the variant of the method 
%%
%%  legendtext = DSA_BD_LegendAppend( OPTIONS)
%%
%% DSA_BD:
%% Modified by C.Ortiz
%% Last Modified: 3/31/2011
function  legendtext = DSA_BD_LegendAppend( OPTIONS)

legendtext = ['DSA_BD V',num2str(OPTIONS.vers)];
if isfield(OPTIONS,'normalize')
    if OPTIONS.normalize == 1
        legendtext = [legendtext,' N'];
    elseif OPTIONS.normalize == 2
        legendtext = [legendtext,' NL'];
    elseif OPTIONS.normalize == 3
        legendtext = [legendtext,' NLP'];
    end
end
if isfield(OPTIONS,'adaptivelambda') && OPTIONS.adaptivelambda == 1
    legendtext = [legendtext,' A'];
end
if isfield(OPTIONS,'balancedinit') && OPTIONS.balancedinit ~= 0
    legendtext = [legendtext,' B',num2str(OPTIONS.balancedinit)];
end
if isfield(OPTIONS,'dynamicscaling') && OPTIONS.dynamicscaling == 1
    
    if isfield(OPTIONS,'scalerelnorm') && OPTIONS.scalerelnorm == 1
        r = ',r';
    else
        r='';
    end
    legendtext = [legendtext,' Dyn(',num2str(OPTIONS.scaleratio), ...
        ',',num2str(OPTIONS.scalecorrection),',', ...
        num2str(OPTIONS.dyn_scale_updateiteration),r,')'];
end
legendtext = [legendtext,' sig=',num2str(OPTIONS.sigma)];


end
