% cholAAt: compute Cholesky factorization of A*At.
%%
%% SDPNAL:
%% Copyright (c) 2008 by
%% Xinyuan Zhao, Defeng Sun, and Kim-Chuan Toh
%%***********************************************************
%% DSA_BD:
%% Modified by C.Ortiz
%% Last Modified: 3/31/2011

function [L,AAt] = DSA_BD_cholAAt(blk,At,m)
AAt = sparse(m,m);
for p = 1:size(blk,1)
    AAt = AAt + At{p,1}'*At{p,1};
end
pertdiag = 1e-13*ones(m,1);
AAt = AAt + spdiags(pertdiag,0,m,m);
%%
if (nnz(AAt) < 0.2*m*m); use_spchol=1; else; use_spchol=0; end
if (use_spchol)
    [L.Rt,L.p,L.S] = chol(AAt,'lower');
    L.R = L.Rt';
    L.St = L.S';
    L.matfct_options = 'spcholmatlab';
else
    if issparse(AAt); AAt = full(AAt); end;
    L.matfct_options = 'chol';
    L.S = eye(m);
    L.St = L.S;
    [L.Rt,L.p] = chol(AAt,'lower');
    L.R = L.Rt';
end
end