%Demo: Examples of SDPs solved by DSA_BD
%%
%% C. Ortiz
%% Las Modified: 3/31/2011
%%*****************************************************************
function DSA_BD_demo(maxiter,tol)
if nargin < 1; maxiter = 3000; end;
if nargin < 2; tol = 1e-6; end
randn('state',0); 
rand('twister',0);
%    feas = input('using feasible starting point? [yes = 1, no = 0] ');
%    if (feas)
%       fprintf('\n  using feasible starting point\n\n');
%    else
%       fprintf('\n  using infeasible starting point\n\n');
%    end
pause(1);

maxprobs = 2;
OPTIONS.vers = 1;
if ~isempty(maxiter); OPTIONS.maxit = maxiter; end
if nargin>=1 && ~isempty(tol); OPTIONS.tol = tol; end

%iterm = zeros(2,6); infom = zeros(2,6); timem = zeros(2,6);

%sqlparameters;

blk =[];
for prob = 1:maxprobs;
    if (prob == 1)
        file = 'fap09';
        disp(['**** From FAP file : ',file, '****'])
        [blk,At,C,b] = fapread(file);
        X0 = cell(size(C));
        Z0 = cell(size(C));
        OPTIONS.n = 0;
        for p = 1:length(C)
            X0{p} = zeros(size(C{p}));
            Z0{p} = zeros(size(C{p}));
            OPTIONS.n(p) = size(C{p},1);
        end;
        OPTIONS.m = length(b);



    elseif (prob == 2)
        file = 'gka2c.sparse';
        disp(['**** From BIQ file : ',file, '****'])
        [Q] = biqread(file);
        [blk2,At2,C2,b2] = biq(Q);
        [blk,At,C,b] = addpositive(blk2,At2,C2,b2);
        X0 = cell(size(C));
        Z0 = cell(size(C));
        OPTIONS.n = 0;
        for p = 1:length(C)
            X0{p} = zeros(size(C{p}));
            Z0{p} = zeros(size(C{p}));
            OPTIONS.n(p) =size(C{p},1);
        end;
        OPTIONS.m = length(b);

    elseif (prob == 3)
        file = 'chr18b.dat';
        disp(['**** From QAP file : ',file, '****'])
        [A,B] = qapread(file);
        [blk2,At2,C2,b2] = qapAW(A,B);
        [blk,At,C,b] = addpositive(blk2,At2,C2,b2);
        X0 = cell(size(C));
        Z0 = cell(size(C));
        OPTIONS.n = 0;
        for p = 1:length(C)
            X0{p} = zeros(size(C{p}));
            Z0{p} = zeros(size(C{p}));
            OPTIONS.n(p) =size(C{p},1);
        end;
        OPTIONS.m = length(b);
 
    elseif (prob == 4)
        disp('******** sparse random sdp **********')
        OPTIONS.n = 300; OPTIONS.m = 20000;
        OPTIONS.p=3;
        rand_seed = 3002030;
        [At, b, C, X0, y0, Z0] = rand_sdps(OPTIONS.n, OPTIONS.m, OPTIONS.p, rand_seed);
        n = size(C,1);
        par.n = n;
        [blk,At,C,b] = Boundary2SDPT3(n,At,b,C);
        y = y0;
        if iscell(Z0); Z = Z0; else Z = {Z0}; end;
        if iscell(X0); X = X0; else X = {X0}; end;
        
    elseif (prob == 5)
        disp('******** dense random sdp **********')
        OPTIONS.n = 50; OPTIONS.m = 500;
        [blk,At,C,b,X0,y0,Z0] = randsdp(OPTIONS.n,OPTIONS.m);

    end



    y0 = zeros(size(b));

    %%
    legends = [];
    h = [];
    for alg = 1 : 1
        clear obj X y Z runhist;
        if alg == 1
            OPTIONS.sigma = 0.99;
            OPTIONS.normalize = 3;
            OPTIONS.adaptivelambda = 1;
            OPTIONS.dynamicscaling = 1;
            OPTIONS.scaleratio = 1.5;
            OPTIONS.scalecorrection = .9;
            OPTIONS.scalerelnorm = 1;
            OPTIONS.dyn_scale_updateiteration = 5;
            OPTIONS.balancedinit = 3;

            [obj,X,y,Z,runhist] = ...
                DSA_BD_SDP_Solver(blk,At,C,b,OPTIONS,X0,y0,Z0);

        elseif alg == 2
            OPTIONS.sigma = 0.99;
            OPTIONS.normalize = 3;
            OPTIONS.adaptivelambda = 0;
            OPTIONS.dynamicscaling =   1;
            OPTIONS.scaleratio = 1.5;
            OPTIONS.scalecorrection = .75;
            OPTIONS.scalerelnorm = 1;
            OPTIONS.dyn_scale_updateiteration = 5;
            OPTIONS.balancedinit = 3;

            [obj,X,y,Z,runhist] = ...
                DSA_BD_SDP_Solver(blk,At,C,b,OPTIONS,X0,y0,Z0);
        end
        [h,legends] = DSA_BD_PlotRunHistory(h,legends,runhist, OPTIONS);
    end
    fprintf('\n**** press enter to continue ****\n'); pause

end
